# Copyright (c) 2000-2013, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Name:           sonatype-http-testing-harness
Summary:        Testing Harness for http-based tests
Url:            http://www.sonatype.org/
Version:        0.5.0
Release:        2%{?dist}
Epoch:          0
License:        Apache Software License 2.0
Group:          Development/Libraries
Source0:        sonatype-http-testing-harness-0.5.0.tar.gz
# git clone git://github.com/sonatype/http-testing-harness.git
# cd http-testing-harness/
# git tag -l
# git archive http-testing-harness-0.5.0 > ../SOURCES/sonatype-http-testing-harness-0.5.0.tar
# gzip ../SOURCES/sonatype-http-testing-harness-0.5.0.tar

Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        http://repo1.maven.org/maven2/com/intellij/annotations/9.0.4/annotations-9.0.4.jar
Source4:        http://repo1.maven.org/maven2/com/intellij/annotations/9.0.4/annotations-9.0.4.pom

Patch0:         sonatype-http-testing-harness-pom.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven-assembly-plugin
BuildRequires:  maven-bundle-plugin
BuildRequires:  maven-compiler-plugin
BuildRequires:  maven-enforcer-plugin
BuildRequires:  maven-install-plugin
BuildRequires:  maven-jar-plugin
BuildRequires:  maven-javadoc-plugin
BuildRequires:  maven-release
BuildRequires:  maven-surefire-plugin
BuildRequires:  maven-surefire-provider-junit3
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven-surefire-provider-testng
BuildRequires:  animal-sniffer
BuildRequires:  apache-commons-parent
BuildRequires:  apache-commons-io2
BuildRequires:  forge-parent
BuildRequires:  google-collections
BuildRequires:  google-pom
BuildRequires:  hamcrest13
BuildRequires:  mojo-parent
BuildRequires:  mojo-signatures
BuildRequires:  jetty7 >= 0:7.6.1
BuildRequires:  junit4
BuildRequires:  logback
BuildRequires:  oss-parent
BuildRequires:  sisu-goodies
BuildRequires:  servlet_2_5_api
BuildRequires:  slf4j
BuildRequires:  testng

Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5
Requires:  java >= 0:1.6.0
Requires:  apache-commons-io2
Requires:  google-collections
Requires:  jetty7 >= 0:7.6.1
Requires:  junit4
Requires:  logback
Requires:  servlet_2_5_api
Requires:  sisu-goodies
Requires:  slf4j
Requires:  testng

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot


%description
The purpose of this harness is to be able to execute the same test code for
many server configurations.  Instead of setting up a server fixture in every
test method, the test methods can be executed multiple times with different server
fixtures. 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -c
chmod -R go=u-w *
for f in $(find . -name "*.jar"); do
  mv $f $f.no
done
cp %{SOURCE1} settings.xml
%patch0 -b .sav0

%build
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export SETTINGS=$(pwd)/settings.xml

mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.failure.ignore=true \
        install 
mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        javadoc:aggregate

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

%add_to_maven_depmap org.sonatype.http-testing-harness hth-parent %{version} JPP/%{name} parent
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-parent.pom

%add_to_maven_depmap org.sonatype.http-testing-harness harness-runner %{version} JPP/%{name} harness-runner
install -m 644 harness-runner/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-harness-runner.pom
install -m 644 harness-runner/target/harness-runner-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/harness-runner-%{version}.jar

%add_to_maven_depmap org.sonatype.http-testing-harness hth-api %{version} JPP/%{name} hth-api
install -m 644 hth-api/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-hth-api.pom
install -m 644 hth-api/target/hth-api-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/hth-api-%{version}.jar

%add_to_maven_depmap org.sonatype.http-testing-harness junit-runner %{version} JPP/%{name} junit-runner
install -m 644 junit-runner/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-junit-runner.pom
install -m 644 junit-runner/target/junit-runner-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/junit-runner-%{version}.jar

%add_to_maven_depmap org.sonatype.http-testing-harness server-provider %{version} JPP/%{name} server-provider
install -m 644 server-provider/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-server-provider.pom
install -m 644 server-provider/target/server-provider-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/server-provider-%{version}.jar

%add_to_maven_depmap org.sonatype.http-testing-harness testng-runner %{version} JPP/%{name} testng-runner
install -m 644 testng-runner/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-testng-runner.pom
install -m 644 testng-runner/target/testng-runner-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/testng-runner-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(-,root,root)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/*

%changelog
* Fri Jan 25 2013 Ralph Apel <r.apel at r-apel.de> 0:0.5.0-2
- Bump release to rebuild, reupload

* Sun Jul 08 2012 Ralph Apel <r.apel at r-apel.de> 0:0.5.0-1
- 0.5.0

